//+------------------------------------------------------------------+
//|                                                         KGHP.mq5 |
//|                                       Copyright 2006, Newdigital |
//|                                        http://www.forex-tsd.com/ |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------------+
//| I wanted to create the KGHP digital filter and was failed.             |
//| But when I attached this indicator to the indicator window together    | 
//| with other filters (in one indicator window) I recognized that         |
//| it is great indicator. It follows the price and seems it is like       |
//| the price curve in the indicator window. Just attach an other filter to|
//| the same window and this KGHP indicator will be as price curve.        |
//| It is very easy to analyze everything.*/                               |
//| --- Parameters: P1=30, D1=29, A1=40                                    |
//| --- P2=52, D2=31, A2=40, Ripple=0.08, Delay=0                          |
//| --- Order [Auto]=858, Calculate method=2                               |
//+------------------------------------------------------------------------+
//--- Copyright
#property copyright "Copyright 2006, Newdigital"
//--- link to the website of the author
#property link      "http://www.finware.ru/"
#property description "Digital High Pass (KGHP) Filter"
#property description "Using the Generator of Digital Filters"
//--- Indicator version
#property version   "1.00"
//--- drawing the indicator in a separate window
#property indicator_separate_window
//--- one buffer is used for calculation and drawing of the indicator
#property indicator_buffers 1
//--- one plot is used
#property indicator_plots   1
//--- drawing the indicator as a line
#property indicator_type1   DRAW_LINE
//---- blue color is used for the indicator line
#property indicator_color1  clrRed
//---- the indicator line is a continuous curve
#property indicator_style1  STYLE_SOLID
//--- indicator line width is 2
#property indicator_width1  2
//--- displaying the indicator label
#property indicator_label1  "KGHP"
//--- indicator input parameters
input int KGHPShift=0; // Horizontal shift of the average in bars 
//--- declaration of the integer variables for the start of data calculation
int min_rates_total;
//---- declaration of a dynamic array that
//---- will be used as an indicator buffer
double ExtLineBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//--- initialization of global variables
   min_rates_total=858;
//--- set ExtLineBuffer dynamic array as indicator buffer
   SetIndexBuffer(0,ExtLineBuffer,INDICATOR_DATA);
//--- shift the indicator horizontally by KGHPSift
   PlotIndexSetInteger(0,PLOT_SHIFT,KGHPShift);
//--- set the position, from which the indicator drawing starts
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//--- restriction to draw empty values for the indicator
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
//--- initializations of a variable for the indicator short name
   string shortname;
   StringConcatenate(shortname,"KGHP(",KGHPShift,")");
//--- Creation of the name to be displayed in a separate sub-window and in a pop up help
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//--- Determining the accuracy of displaying the indicator values
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//---
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,     // number of bars in history at the current tick
                const int prev_calculated, // number of bars calculated at previous call
                const int begin,           // index of the beginning of reliable bars counting
                const double &price[])     // price array for calculation of the indicator
  {
//--- checking if the number of bars is enough for the calculation
   if(rates_total<min_rates_total-1+begin) return(0);

//--- declarations of local variables 
   int first,bar;
   double KGHP;

//--- calculation of the 'first' starting index for the bars recalculation loop
   if(prev_calculated>rates_total || prev_calculated<=0) // checking for the first start of calculation of an indicator
     {
      first=min_rates_total-1+begin;  // starting index for calculation of all bars
      //--- increase the position of the data start by 'begin' bars as a result of the calculation using data of another indicator
      if(begin>0) PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,begin+min_rates_total);
     }
   else first=prev_calculated-1; // starting number for calculation of new bars

//--- main indicator calculation loop
   for(bar=first; bar<rates_total; bar++)
     {
      //--- 
      KGHP=1.0000000000000000000*price[bar-0]
           +0.000000000000000039*price[bar-1]
           -0.000000000000000038*price[bar-2]
           +0.000000000000000038*price[bar-3]
           -0.000000000000000039*price[bar-4]
           +0.000000000000000039*price[bar-5]
           -0.000000000000000039*price[bar-6]
           +0.000000000000000038*price[bar-7]
           -0.000000000000000039*price[bar-8]
           +0.000000000000000039*price[bar-9]
           -0.000000000000000039*price[bar-10]
           +0.000000000000000038*price[bar-11]
           -0.000000000000000039*price[bar-12]
           +0.000000000000000039*price[bar-13]
           -0.000000000000000039*price[bar-14]
           +0.000000000000000038*price[bar-15]
           -0.000000000000000039*price[bar-16]
           +0.000000000000000039*price[bar-17]
           -0.000000000000000039*price[bar-18]
           +0.000000000000000038*price[bar-19]
           -0.000000000000000039*price[bar-20]
           +0.000000000000000039*price[bar-21]
           -0.000000000000000038*price[bar-22]
           +0.000000000000000039*price[bar-23]
           -0.000000000000000039*price[bar-24]
           +0.000000000000000039*price[bar-25]
           -0.000000000000000039*price[bar-26]
           +0.000000000000000038*price[bar-27]
           -0.000000000000000039*price[bar-28]
           +0.000000000000000039*price[bar-29]
           -0.000000000000000039*price[bar-30]
           +0.000000000000000038*price[bar-31]
           -0.000000000000000039*price[bar-32]
           +0.000000000000000039*price[bar-33]
           -0.000000000000000039*price[bar-34]
           +0.000000000000000039*price[bar-35]
           -0.000000000000000039*price[bar-36]
           +0.000000000000000039*price[bar-37]
           -0.000000000000000039*price[bar-38]
           +0.000000000000000039*price[bar-39]
           -0.000000000000000039*price[bar-40]
           +0.000000000000000039*price[bar-41]
           -0.000000000000000039*price[bar-42]
           +0.000000000000000039*price[bar-43]
           -0.000000000000000039*price[bar-44]
           +0.000000000000000039*price[bar-45]
           -0.000000000000000039*price[bar-46]
           +0.000000000000000039*price[bar-47]
           -0.000000000000000039*price[bar-48]
           +0.000000000000000039*price[bar-49]
           -0.000000000000000039*price[bar-50]
           +0.000000000000000039*price[bar-51]
           -0.000000000000000039*price[bar-52]
           +0.000000000000000039*price[bar-53]
           -0.000000000000000039*price[bar-54]
           +0.000000000000000039*price[bar-55]
           -0.000000000000000039*price[bar-56]
           +0.000000000000000039*price[bar-57]
           -0.000000000000000039*price[bar-58]
           +0.000000000000000039*price[bar-59]
           -0.000000000000000039*price[bar-60]
           +0.000000000000000039*price[bar-61]
           -0.000000000000000039*price[bar-62]
           +0.000000000000000039*price[bar-63]
           -0.000000000000000039*price[bar-64]
           +0.000000000000000039*price[bar-65]
           -0.000000000000000039*price[bar-66]
           +0.000000000000000039*price[bar-67]
           -0.000000000000000039*price[bar-68]
           +0.000000000000000039*price[bar-69]
           -0.000000000000000039*price[bar-70]
           +0.000000000000000039*price[bar-71]
           -0.000000000000000039*price[bar-72]
           +0.000000000000000039*price[bar-73]
           -0.000000000000000039*price[bar-74]
           +0.000000000000000039*price[bar-75]
           -0.000000000000000039*price[bar-76]
           +0.000000000000000039*price[bar-77]
           -0.000000000000000039*price[bar-78]
           +0.000000000000000039*price[bar-79]
           -0.000000000000000039*price[bar-80]
           +0.000000000000000039*price[bar-81]
           -0.000000000000000039*price[bar-82]
           +0.000000000000000039*price[bar-83]
           -0.000000000000000039*price[bar-84]
           +0.000000000000000039*price[bar-85]
           -0.000000000000000039*price[bar-86]
           +0.000000000000000039*price[bar-87]
           -0.000000000000000039*price[bar-88]
           +0.000000000000000039*price[bar-89]
           -0.000000000000000039*price[bar-90]
           +0.000000000000000039*price[bar-91]
           -0.000000000000000039*price[bar-92]
           +0.000000000000000039*price[bar-93]
           -0.000000000000000039*price[bar-94]
           +0.000000000000000039*price[bar-95]
           -0.000000000000000039*price[bar-96]
           +0.000000000000000039*price[bar-97]
           -0.000000000000000039*price[bar-98]
           +0.000000000000000039*price[bar-99]
           -0.000000000000000039*price[bar-100]
           +0.000000000000000039*price[bar-101]
           -0.000000000000000039*price[bar-102]
           +0.000000000000000039*price[bar-103]
           -0.000000000000000039*price[bar-104]
           +0.000000000000000039*price[bar-105]
           -0.000000000000000039*price[bar-106]
           +0.000000000000000039*price[bar-107]
           -0.000000000000000039*price[bar-108]
           +0.000000000000000039*price[bar-109]
           -0.000000000000000039*price[bar-110]
           +0.000000000000000039*price[bar-111]
           -0.000000000000000039*price[bar-112]
           +0.000000000000000039*price[bar-113]
           -0.000000000000000039*price[bar-114]
           +0.000000000000000039*price[bar-115]
           -0.000000000000000039*price[bar-116]
           +0.000000000000000039*price[bar-117]
           -0.000000000000000039*price[bar-118]
           +0.000000000000000039*price[bar-119]
           -0.000000000000000039*price[bar-120]
           +0.000000000000000039*price[bar-121]
           -0.000000000000000039*price[bar-122]
           +0.000000000000000039*price[bar-123]
           -0.000000000000000039*price[bar-124]
           +0.000000000000000039*price[bar-125]
           -0.000000000000000039*price[bar-126]
           +0.000000000000000039*price[bar-127]
           -0.000000000000000039*price[bar-128]
           +0.000000000000000039*price[bar-129]
           -0.000000000000000039*price[bar-130]
           +0.000000000000000039*price[bar-131]
           -0.000000000000000039*price[bar-132]
           +0.000000000000000039*price[bar-133]
           -0.000000000000000039*price[bar-134]
           +0.000000000000000039*price[bar-135]
           -0.000000000000000039*price[bar-136]
           +0.000000000000000039*price[bar-137]
           -0.000000000000000039*price[bar-138]
           +0.000000000000000039*price[bar-139]
           -0.000000000000000039*price[bar-140]
           +0.000000000000000039*price[bar-141]
           -0.000000000000000039*price[bar-142]
           +0.000000000000000039*price[bar-143]
           -0.000000000000000039*price[bar-144]
           +0.000000000000000039*price[bar-145]
           -0.000000000000000039*price[bar-146]
           +0.000000000000000039*price[bar-147]
           -0.000000000000000039*price[bar-148]
           +0.000000000000000039*price[bar-149]
           -0.000000000000000039*price[bar-150]
           +0.000000000000000039*price[bar-151]
           -0.000000000000000039*price[bar-152]
           +0.000000000000000039*price[bar-153]
           -0.000000000000000039*price[bar-154]
           +0.000000000000000039*price[bar-155]
           -0.000000000000000039*price[bar-156]
           +0.000000000000000039*price[bar-157]
           -0.000000000000000039*price[bar-158]
           +0.000000000000000039*price[bar-159]
           -0.000000000000000039*price[bar-160]
           +0.000000000000000039*price[bar-161]
           -0.000000000000000039*price[bar-162]
           +0.000000000000000039*price[bar-163]
           -0.000000000000000039*price[bar-164]
           +0.000000000000000039*price[bar-165]
           -0.000000000000000039*price[bar-166]
           +0.000000000000000039*price[bar-167]
           -0.000000000000000039*price[bar-168]
           +0.000000000000000039*price[bar-169]
           -0.000000000000000039*price[bar-170]
           +0.000000000000000039*price[bar-171]
           -0.000000000000000039*price[bar-172]
           +0.000000000000000039*price[bar-173]
           -0.000000000000000039*price[bar-174]
           +0.000000000000000039*price[bar-175]
           -0.000000000000000039*price[bar-176]
           +0.000000000000000040*price[bar-177]
           -0.000000000000000039*price[bar-178]
           +0.000000000000000039*price[bar-179]
           -0.000000000000000039*price[bar-180]
           +0.000000000000000039*price[bar-181]
           -0.000000000000000039*price[bar-182]
           +0.000000000000000039*price[bar-183]
           -0.000000000000000039*price[bar-184]
           +0.000000000000000039*price[bar-185]
           -0.000000000000000039*price[bar-186]
           +0.000000000000000039*price[bar-187]
           -0.000000000000000039*price[bar-188]
           +0.000000000000000039*price[bar-189]
           -0.000000000000000039*price[bar-190]
           +0.000000000000000039*price[bar-191]
           -0.000000000000000039*price[bar-192]
           +0.000000000000000039*price[bar-193]
           -0.000000000000000039*price[bar-194]
           +0.000000000000000039*price[bar-195]
           -0.000000000000000039*price[bar-196]
           +0.000000000000000039*price[bar-197]
           -0.000000000000000039*price[bar-198]
           +0.000000000000000039*price[bar-199]
           -0.000000000000000039*price[bar-200]
           +0.000000000000000039*price[bar-201]
           -0.000000000000000039*price[bar-202]
           +0.000000000000000039*price[bar-203]
           -0.000000000000000039*price[bar-204]
           +0.000000000000000039*price[bar-205]
           -0.000000000000000039*price[bar-206]
           +0.000000000000000040*price[bar-207]
           -0.000000000000000040*price[bar-208]
           +0.000000000000000041*price[bar-209]
           -0.000000000000000039*price[bar-210]
           +0.000000000000000039*price[bar-211]
           -0.000000000000000040*price[bar-212]
           +0.000000000000000039*price[bar-213]
           -0.000000000000000039*price[bar-214]
           +0.000000000000000039*price[bar-215]
           -0.000000000000000040*price[bar-216]
           +0.000000000000000039*price[bar-217]
           -0.000000000000000040*price[bar-218]
           +0.000000000000000039*price[bar-219]
           -0.000000000000000040*price[bar-220]
           +0.000000000000000039*price[bar-221]
           -0.000000000000000040*price[bar-222]
           +0.000000000000000040*price[bar-223]
           -0.000000000000000040*price[bar-224]
           +0.000000000000000040*price[bar-225]
           -0.000000000000000040*price[bar-226]
           +0.000000000000000040*price[bar-227]
           -0.000000000000000040*price[bar-228]
           +0.000000000000000040*price[bar-229]
           -0.000000000000000040*price[bar-230]
           +0.000000000000000040*price[bar-231]
           -0.000000000000000040*price[bar-232]
           +0.000000000000000040*price[bar-233]
           -0.000000000000000040*price[bar-234]
           +0.000000000000000040*price[bar-235]
           -0.000000000000000040*price[bar-236]
           +0.000000000000000040*price[bar-237]
           -0.000000000000000040*price[bar-238]
           +0.000000000000000040*price[bar-239]
           -0.000000000000000040*price[bar-240]
           +0.000000000000000040*price[bar-241]
           -0.000000000000000040*price[bar-242]
           +0.000000000000000040*price[bar-243]
           -0.000000000000000040*price[bar-244]
           +0.000000000000000040*price[bar-245]
           -0.000000000000000040*price[bar-246]
           +0.000000000000000040*price[bar-247]
           -0.000000000000000040*price[bar-248]
           +0.000000000000000040*price[bar-249]
           -0.000000000000000040*price[bar-250]
           +0.000000000000000040*price[bar-251]
           -0.000000000000000041*price[bar-252]
           +0.000000000000000040*price[bar-253]
           -0.000000000000000040*price[bar-254]
           +0.000000000000000040*price[bar-255]
           -0.000000000000000040*price[bar-256]
           +0.000000000000000040*price[bar-257]
           -0.000000000000000040*price[bar-258]
           +0.000000000000000040*price[bar-259]
           -0.000000000000000040*price[bar-260]
           +0.000000000000000040*price[bar-261]
           -0.000000000000000040*price[bar-262]
           +0.000000000000000040*price[bar-263]
           -0.000000000000000040*price[bar-264]
           +0.000000000000000040*price[bar-265]
           -0.000000000000000040*price[bar-266]
           +0.000000000000000040*price[bar-267]
           -0.000000000000000040*price[bar-268]
           +0.000000000000000040*price[bar-269]
           -0.000000000000000040*price[bar-270]
           +0.000000000000000040*price[bar-271]
           -0.000000000000000040*price[bar-272]
           +0.000000000000000040*price[bar-273]
           -0.000000000000000040*price[bar-274]
           +0.000000000000000040*price[bar-275]
           -0.000000000000000040*price[bar-276]
           +0.000000000000000041*price[bar-277]
           -0.000000000000000040*price[bar-278]
           +0.000000000000000040*price[bar-279]
           -0.000000000000000041*price[bar-280]
           +0.000000000000000040*price[bar-281]
           -0.000000000000000040*price[bar-282]
           +0.000000000000000040*price[bar-283]
           -0.000000000000000041*price[bar-284]
           +0.000000000000000040*price[bar-285]
           -0.000000000000000040*price[bar-286]
           +0.000000000000000041*price[bar-287]
           -0.000000000000000040*price[bar-288]
           +0.000000000000000040*price[bar-289]
           -0.000000000000000040*price[bar-290]
           +0.000000000000000040*price[bar-291]
           -0.000000000000000040*price[bar-292]
           +0.000000000000000041*price[bar-293]
           -0.000000000000000040*price[bar-294]
           +0.000000000000000040*price[bar-295]
           -0.000000000000000041*price[bar-296]
           +0.000000000000000041*price[bar-297]
           -0.000000000000000040*price[bar-298]
           +0.000000000000000041*price[bar-299]
           -0.000000000000000040*price[bar-300]
           +0.000000000000000040*price[bar-301]
           -0.000000000000000041*price[bar-302]
           +0.000000000000000041*price[bar-303]
           -0.000000000000000040*price[bar-304]
           +0.000000000000000041*price[bar-305]
           -0.000000000000000041*price[bar-306]
           +0.000000000000000041*price[bar-307]
           -0.000000000000000041*price[bar-308]
           +0.000000000000000041*price[bar-309]
           -0.000000000000000041*price[bar-310]
           +0.000000000000000041*price[bar-311]
           -0.000000000000000041*price[bar-312]
           +0.000000000000000041*price[bar-313]
           -0.000000000000000041*price[bar-314]
           +0.000000000000000041*price[bar-315]
           -0.000000000000000041*price[bar-316]
           +0.000000000000000041*price[bar-317]
           -0.000000000000000041*price[bar-318]
           +0.000000000000000041*price[bar-319]
           -0.000000000000000041*price[bar-320]
           +0.000000000000000041*price[bar-321]
           -0.000000000000000041*price[bar-322]
           +0.000000000000000041*price[bar-323]
           -0.000000000000000041*price[bar-324]
           +0.000000000000000041*price[bar-325]
           -0.000000000000000041*price[bar-326]
           +0.000000000000000041*price[bar-327]
           -0.000000000000000041*price[bar-328]
           +0.000000000000000041*price[bar-329]
           -0.000000000000000041*price[bar-330]
           +0.000000000000000041*price[bar-331]
           -0.000000000000000041*price[bar-332]
           +0.000000000000000041*price[bar-333]
           -0.000000000000000041*price[bar-334]
           +0.000000000000000041*price[bar-335]
           -0.000000000000000041*price[bar-336]
           +0.000000000000000041*price[bar-337]
           -0.000000000000000041*price[bar-338]
           +0.000000000000000041*price[bar-339]
           -0.000000000000000042*price[bar-340]
           +0.000000000000000041*price[bar-341]
           -0.000000000000000041*price[bar-342]
           +0.000000000000000041*price[bar-343]
           -0.000000000000000041*price[bar-344]
           +0.000000000000000041*price[bar-345]
           -0.000000000000000041*price[bar-346]
           +0.000000000000000041*price[bar-347]
           -0.000000000000000043*price[bar-348]
           +0.000000000000000041*price[bar-349]
           -0.000000000000000041*price[bar-350]
           +0.000000000000000041*price[bar-351]
           -0.000000000000000041*price[bar-352]
           +0.000000000000000041*price[bar-353]
           -0.000000000000000041*price[bar-354]
           +0.000000000000000041*price[bar-355]
           -0.000000000000000041*price[bar-356]
           +0.000000000000000041*price[bar-357]
           -0.000000000000000042*price[bar-358]
           +0.000000000000000041*price[bar-359]
           -0.000000000000000042*price[bar-360]
           +0.000000000000000042*price[bar-361]
           -0.000000000000000042*price[bar-362]
           +0.000000000000000042*price[bar-363]
           -0.000000000000000042*price[bar-364]
           +0.000000000000000042*price[bar-365]
           -0.000000000000000042*price[bar-366]
           +0.000000000000000042*price[bar-367]
           -0.000000000000000042*price[bar-368]
           +0.000000000000000042*price[bar-369]
           -0.000000000000000042*price[bar-370]
           +0.000000000000000042*price[bar-371]
           -0.000000000000000042*price[bar-372]
           +0.000000000000000042*price[bar-373]
           -0.000000000000000042*price[bar-374]
           +0.000000000000000042*price[bar-375]
           -0.000000000000000041*price[bar-376]
           +0.000000000000000042*price[bar-377]
           -0.000000000000000042*price[bar-378]
           +0.000000000000000042*price[bar-379]
           -0.000000000000000042*price[bar-380]
           +0.000000000000000042*price[bar-381]
           -0.000000000000000043*price[bar-382]
           +0.000000000000000042*price[bar-383]
           -0.000000000000000042*price[bar-384]
           +0.000000000000000042*price[bar-385]
           -0.000000000000000042*price[bar-386]
           +0.000000000000000041*price[bar-387]
           -0.000000000000000042*price[bar-388]
           +0.000000000000000042*price[bar-389]
           -0.000000000000000042*price[bar-390]
           +0.000000000000000042*price[bar-391]
           -0.000000000000000042*price[bar-392]
           +0.000000000000000042*price[bar-393]
           -0.000000000000000042*price[bar-394]
           +0.000000000000000042*price[bar-395]
           -0.000000000000000042*price[bar-396]
           +0.000000000000000042*price[bar-397]
           -0.000000000000000042*price[bar-398]
           +0.000000000000000042*price[bar-399]
           -0.000000000000000042*price[bar-400]
           +0.000000000000000042*price[bar-401]
           -0.000000000000000042*price[bar-402]
           +0.000000000000000042*price[bar-403]
           -0.000000000000000042*price[bar-404]
           +0.000000000000000042*price[bar-405]
           -0.000000000000000043*price[bar-406]
           +0.000000000000000043*price[bar-407]
           -0.000000000000000042*price[bar-408]
           +0.000000000000000042*price[bar-409]
           -0.000000000000000043*price[bar-410]
           +0.000000000000000043*price[bar-411]
           -0.000000000000000042*price[bar-412]
           +0.000000000000000043*price[bar-413]
           -0.000000000000000042*price[bar-414]
           +0.000000000000000041*price[bar-415]
           -0.000000000000000043*price[bar-416]
           +0.000000000000000043*price[bar-417]
           -0.000000000000000042*price[bar-418]
           +0.000000000000000042*price[bar-419]
           -0.000000000000000043*price[bar-420]
           +0.000000000000000042*price[bar-421]
           -0.000000000000000043*price[bar-422]
           +0.000000000000000042*price[bar-423]
           -0.000000000000000043*price[bar-424]
           +0.000000000000000043*price[bar-425]
           -0.000000000000000043*price[bar-426]
           +0.000000000000000043*price[bar-427]
           -0.000000000000000043*price[bar-428]
           +0.000000000000000043*price[bar-429]
           -0.000000000000000043*price[bar-430]
           +0.000000000000000043*price[bar-431]
           -0.000000000000000043*price[bar-432]
           +0.000000000000000043*price[bar-433]
           -0.000000000000000043*price[bar-434]
           +0.000000000000000043*price[bar-435]
           -0.000000000000000043*price[bar-436]
           +0.000000000000000043*price[bar-437]
           -0.000000000000000043*price[bar-438]
           +0.000000000000000043*price[bar-439]
           -0.000000000000000043*price[bar-440]
           +0.000000000000000043*price[bar-441]
           -0.000000000000000043*price[bar-442]
           +0.000000000000000043*price[bar-443]
           -0.000000000000000043*price[bar-444]
           +0.000000000000000043*price[bar-445]
           -0.000000000000000043*price[bar-446]
           +0.000000000000000043*price[bar-447]
           -0.000000000000000043*price[bar-448]
           +0.000000000000000043*price[bar-449]
           -0.000000000000000047*price[bar-450]
           +0.000000000000000043*price[bar-451]
           -0.000000000000000044*price[bar-452]
           +0.000000000000000043*price[bar-453]
           -0.000000000000000043*price[bar-454]
           +0.000000000000000043*price[bar-455]
           -0.000000000000000043*price[bar-456]
           +0.000000000000000042*price[bar-457]
           -0.000000000000000043*price[bar-458]
           +0.000000000000000044*price[bar-459]
           -0.000000000000000043*price[bar-460]
           +0.000000000000000044*price[bar-461]
           -0.000000000000000044*price[bar-462]
           +0.000000000000000044*price[bar-463]
           -0.000000000000000044*price[bar-464]
           +0.000000000000000044*price[bar-465]
           -0.000000000000000044*price[bar-466]
           +0.000000000000000044*price[bar-467]
           -0.000000000000000044*price[bar-468]
           +0.000000000000000044*price[bar-469]
           -0.000000000000000044*price[bar-470]
           +0.000000000000000044*price[bar-471]
           -0.000000000000000044*price[bar-472]
           +0.000000000000000044*price[bar-473]
           -0.000000000000000044*price[bar-474]
           +0.000000000000000044*price[bar-475]
           -0.000000000000000044*price[bar-476]
           +0.000000000000000044*price[bar-477]
           -0.000000000000000044*price[bar-478]
           +0.000000000000000044*price[bar-479]
           -0.000000000000000044*price[bar-480]
           +0.000000000000000044*price[bar-481]
           -0.000000000000000045*price[bar-482]
           +0.000000000000000044*price[bar-483]
           -0.000000000000000044*price[bar-484]
           +0.000000000000000044*price[bar-485]
           -0.000000000000000044*price[bar-486]
           +0.000000000000000044*price[bar-487]
           -0.000000000000000044*price[bar-488]
           +0.000000000000000044*price[bar-489]
           -0.000000000000000044*price[bar-490]
           +0.000000000000000045*price[bar-491]
           -0.000000000000000044*price[bar-492]
           +0.000000000000000044*price[bar-493]
           -0.000000000000000044*price[bar-494]
           +0.000000000000000044*price[bar-495]
           -0.000000000000000044*price[bar-496]
           +0.000000000000000044*price[bar-497]
           -0.000000000000000045*price[bar-498]
           +0.000000000000000045*price[bar-499]
           -0.000000000000000044*price[bar-500]
           +0.000000000000000044*price[bar-501]
           -0.000000000000000044*price[bar-502]
           +0.000000000000000045*price[bar-503]
           -0.000000000000000045*price[bar-504]
           +0.000000000000000045*price[bar-505]
           -0.000000000000000045*price[bar-506]
           +0.000000000000000045*price[bar-507]
           -0.000000000000000044*price[bar-508]
           +0.000000000000000045*price[bar-509]
           -0.000000000000000045*price[bar-510]
           +0.000000000000000045*price[bar-511]
           -0.000000000000000045*price[bar-512]
           +0.000000000000000045*price[bar-513]
           -0.000000000000000045*price[bar-514]
           +0.000000000000000045*price[bar-515]
           -0.000000000000000045*price[bar-516]
           +0.000000000000000045*price[bar-517]
           -0.000000000000000045*price[bar-518]
           +0.000000000000000045*price[bar-519]
           -0.000000000000000045*price[bar-520]
           +0.000000000000000045*price[bar-521]
           -0.000000000000000043*price[bar-522]
           +0.000000000000000046*price[bar-523]
           -0.000000000000000045*price[bar-524]
           +0.000000000000000045*price[bar-525]
           -0.000000000000000045*price[bar-526]
           +0.000000000000000045*price[bar-527]
           -0.000000000000000045*price[bar-528]
           +0.000000000000000046*price[bar-529]
           -0.000000000000000045*price[bar-530]
           +0.000000000000000046*price[bar-531]
           -0.000000000000000046*price[bar-532]
           +0.000000000000000046*price[bar-533]
           -0.000000000000000046*price[bar-534]
           +0.000000000000000045*price[bar-535]
           -0.000000000000000046*price[bar-536]
           +0.000000000000000045*price[bar-537]
           -0.000000000000000046*price[bar-538]
           +0.000000000000000046*price[bar-539]
           -0.000000000000000046*price[bar-540]
           +0.000000000000000045*price[bar-541]
           -0.000000000000000046*price[bar-542]
           +0.000000000000000046*price[bar-543]
           -0.000000000000000046*price[bar-544]
           +0.000000000000000046*price[bar-545]
           -0.000000000000000046*price[bar-546]
           +0.000000000000000045*price[bar-547]
           -0.000000000000000046*price[bar-548]
           +0.000000000000000046*price[bar-549]
           -0.000000000000000046*price[bar-550]
           +0.000000000000000046*price[bar-551]
           -0.000000000000000046*price[bar-552]
           +0.000000000000000046*price[bar-553]
           -0.000000000000000046*price[bar-554]
           +0.000000000000000046*price[bar-555]
           -0.000000000000000046*price[bar-556]
           +0.000000000000000046*price[bar-557]
           -0.000000000000000044*price[bar-558]
           +0.000000000000000046*price[bar-559]
           -0.000000000000000046*price[bar-560]
           +0.000000000000000046*price[bar-561]
           -0.000000000000000046*price[bar-562]
           +0.000000000000000046*price[bar-563]
           -0.000000000000000046*price[bar-564]
           +0.000000000000000047*price[bar-565]
           -0.000000000000000047*price[bar-566]
           +0.000000000000000046*price[bar-567]
           -0.000000000000000047*price[bar-568]
           +0.000000000000000047*price[bar-569]
           -0.000000000000000047*price[bar-570]
           +0.000000000000000046*price[bar-571]
           -0.000000000000000047*price[bar-572]
           +0.000000000000000046*price[bar-573]
           -0.000000000000000047*price[bar-574]
           +0.000000000000000047*price[bar-575]
           -0.000000000000000047*price[bar-576]
           +0.000000000000000047*price[bar-577]
           -0.000000000000000047*price[bar-578]
           +0.000000000000000047*price[bar-579]
           -0.000000000000000046*price[bar-580]
           +0.000000000000000047*price[bar-581]
           -0.000000000000000047*price[bar-582]
           +0.000000000000000047*price[bar-583]
           -0.000000000000000047*price[bar-584]
           +0.000000000000000047*price[bar-585]
           -0.000000000000000047*price[bar-586]
           +0.000000000000000047*price[bar-587]
           -0.000000000000000047*price[bar-588]
           +0.000000000000000047*price[bar-589]
           -0.000000000000000048*price[bar-590]
           +0.000000000000000047*price[bar-591]
           -0.000000000000000048*price[bar-592]
           +0.000000000000000048*price[bar-593]
           -0.000000000000000048*price[bar-594]
           +0.000000000000000048*price[bar-595]
           -0.000000000000000049*price[bar-596]
           +0.000000000000000047*price[bar-597]
           -0.000000000000000047*price[bar-598]
           +0.000000000000000046*price[bar-599]
           -0.000000000000000048*price[bar-600]
           +0.000000000000000048*price[bar-601]
           -0.000000000000000048*price[bar-602]
           +0.000000000000000048*price[bar-603]
           -0.000000000000000048*price[bar-604]
           +0.000000000000000048*price[bar-605]
           -0.000000000000000048*price[bar-606]
           +0.000000000000000048*price[bar-607]
           -0.000000000000000048*price[bar-608]
           +0.000000000000000048*price[bar-609]
           -0.000000000000000048*price[bar-610]
           +0.000000000000000048*price[bar-611]
           -0.000000000000000048*price[bar-612]
           +0.000000000000000048*price[bar-613]
           -0.000000000000000048*price[bar-614]
           +0.000000000000000048*price[bar-615]
           -0.000000000000000048*price[bar-616]
           +0.000000000000000048*price[bar-617]
           -0.000000000000000048*price[bar-618]
           +0.000000000000000048*price[bar-619]
           -0.000000000000000048*price[bar-620]
           +0.000000000000000048*price[bar-621]
           -0.000000000000000049*price[bar-622]
           +0.000000000000000049*price[bar-623]
           -0.000000000000000049*price[bar-624]
           +0.000000000000000049*price[bar-625]
           -0.000000000000000048*price[bar-626]
           +0.000000000000000049*price[bar-627]
           -0.000000000000000052*price[bar-628]
           +0.000000000000000049*price[bar-629]
           -0.000000000000000049*price[bar-630]
           +0.000000000000000049*price[bar-631]
           -0.000000000000000049*price[bar-632]
           +0.000000000000000049*price[bar-633]
           -0.000000000000000049*price[bar-634]
           +0.000000000000000049*price[bar-635]
           -0.000000000000000049*price[bar-636]
           +0.000000000000000049*price[bar-637]
           -0.000000000000000049*price[bar-638]
           +0.000000000000000049*price[bar-639]
           -0.000000000000000049*price[bar-640]
           +0.000000000000000049*price[bar-641]
           -0.000000000000000049*price[bar-642]
           +0.000000000000000049*price[bar-643]
           -0.000000000000000049*price[bar-644]
           +0.000000000000000049*price[bar-645]
           -0.000000000000000049*price[bar-646]
           +0.000000000000000050*price[bar-647]
           -0.000000000000000050*price[bar-648]
           +0.000000000000000050*price[bar-649]
           -0.000000000000000049*price[bar-650]
           +0.000000000000000050*price[bar-651]
           -0.000000000000000050*price[bar-652]
           +0.000000000000000050*price[bar-653]
           -0.000000000000000050*price[bar-654]
           +0.000000000000000050*price[bar-655]
           -0.000000000000000050*price[bar-656]
           +0.000000000000000050*price[bar-657]
           -0.000000000000000049*price[bar-658]
           +0.000000000000000050*price[bar-659]
           -0.000000000000000050*price[bar-660]
           +0.000000000000000050*price[bar-661]
           -0.000000000000000051*price[bar-662]
           +0.000000000000000050*price[bar-663]
           -0.000000000000000050*price[bar-664]
           +0.000000000000000050*price[bar-665]
           -0.000000000000000050*price[bar-666]
           +0.000000000000000051*price[bar-667]
           -0.000000000000000049*price[bar-668]
           +0.000000000000000052*price[bar-669]
           -0.000000000000000047*price[bar-670]
           +0.000000000000000050*price[bar-671]
           -0.000000000000000051*price[bar-672]
           +0.000000000000000050*price[bar-673]
           -0.000000000000000050*price[bar-674]
           +0.000000000000000050*price[bar-675]
           -0.000000000000000050*price[bar-676]
           +0.000000000000000050*price[bar-677]
           -0.000000000000000050*price[bar-678]
           +0.000000000000000051*price[bar-679]
           -0.000000000000000051*price[bar-680]
           +0.000000000000000050*price[bar-681]
           -0.000000000000000051*price[bar-682]
           +0.000000000000000051*price[bar-683]
           -0.000000000000000050*price[bar-684]
           +0.000000000000000051*price[bar-685]
           -0.000000000000000051*price[bar-686]
           +0.000000000000000051*price[bar-687]
           -0.000000000000000052*price[bar-688]
           +0.000000000000000051*price[bar-689]
           -0.000000000000000051*price[bar-690]
           +0.000000000000000052*price[bar-691]
           -0.000000000000000052*price[bar-692]
           +0.000000000000000051*price[bar-693]
           -0.000000000000000052*price[bar-694]
           +0.000000000000000051*price[bar-695]
           -0.000000000000000050*price[bar-696]
           +0.000000000000000050*price[bar-697]
           -0.000000000000000051*price[bar-698]
           +0.000000000000000052*price[bar-699]
           -0.000000000000000052*price[bar-700]
           +0.000000000000000052*price[bar-701]
           -0.000000000000000052*price[bar-702]
           +0.000000000000000052*price[bar-703]
           -0.000000000000000052*price[bar-704]
           +0.000000000000000051*price[bar-705]
           -0.000000000000000053*price[bar-706]
           +0.000000000000000052*price[bar-707]
           -0.000000000000000052*price[bar-708]
           +0.000000000000000053*price[bar-709]
           -0.000000000000000052*price[bar-710]
           +0.000000000000000052*price[bar-711]
           -0.000000000000000053*price[bar-712]
           +0.000000000000000052*price[bar-713]
           -0.000000000000000052*price[bar-714]
           +0.000000000000000053*price[bar-715]
           -0.000000000000000053*price[bar-716]
           +0.000000000000000052*price[bar-717]
           -0.000000000000000053*price[bar-718]
           +0.000000000000000052*price[bar-719]
           -0.000000000000000053*price[bar-720]
           +0.000000000000000051*price[bar-721]
           -0.000000000000000053*price[bar-722]
           +0.000000000000000053*price[bar-723]
           -0.000000000000000053*price[bar-724]
           +0.000000000000000054*price[bar-725]
           -0.000000000000000053*price[bar-726]
           +0.000000000000000053*price[bar-727]
           -0.000000000000000055*price[bar-728]
           +0.000000000000000053*price[bar-729]
           -0.000000000000000053*price[bar-730]
           +0.000000000000000053*price[bar-731]
           -0.000000000000000054*price[bar-732]
           +0.000000000000000053*price[bar-733]
           -0.000000000000000053*price[bar-734]
           +0.000000000000000053*price[bar-735]
           -0.000000000000000053*price[bar-736]
           +0.000000000000000054*price[bar-737]
           -0.000000000000000054*price[bar-738]
           +0.000000000000000054*price[bar-739]
           -0.000000000000000054*price[bar-740]
           +0.000000000000000054*price[bar-741]
           -0.000000000000000053*price[bar-742]
           +0.000000000000000054*price[bar-743]
           -0.000000000000000053*price[bar-744]
           +0.000000000000000054*price[bar-745]
           -0.000000000000000053*price[bar-746]
           +0.000000000000000054*price[bar-747]
           -0.000000000000000054*price[bar-748]
           +0.000000000000000053*price[bar-749]
           -0.000000000000000054*price[bar-750]
           +0.000000000000000054*price[bar-751]
           -0.000000000000000054*price[bar-752]
           +0.000000000000000054*price[bar-753]
           -0.000000000000000054*price[bar-754]
           +0.000000000000000054*price[bar-755]
           -0.000000000000000055*price[bar-756]
           +0.000000000000000055*price[bar-757]
           -0.000000000000000054*price[bar-758]
           +0.000000000000000055*price[bar-759]
           -0.000000000000000056*price[bar-760]
           +0.000000000000000055*price[bar-761]
           -0.000000000000000052*price[bar-762]
           +0.000000000000000054*price[bar-763]
           -0.000000000000000056*price[bar-764]
           +0.000000000000000054*price[bar-765]
           -0.000000000000000054*price[bar-766]
           +0.000000000000000055*price[bar-767]
           -0.000000000000000055*price[bar-768]
           +0.000000000000000055*price[bar-769]
           -0.000000000000000055*price[bar-770]
           +0.000000000000000055*price[bar-771]
           -0.000000000000000055*price[bar-772]
           +0.000000000000000056*price[bar-773]
           -0.000000000000000055*price[bar-774]
           +0.000000000000000054*price[bar-775]
           -0.000000000000000055*price[bar-776]
           +0.000000000000000056*price[bar-777]
           -0.000000000000000055*price[bar-778]
           +0.000000000000000056*price[bar-779]
           -0.000000000000000056*price[bar-780]
           +0.000000000000000056*price[bar-781]
           -0.000000000000000056*price[bar-782]
           +0.000000000000000056*price[bar-783]
           -0.000000000000000056*price[bar-784]
           +0.000000000000000056*price[bar-785]
           -0.000000000000000056*price[bar-786]
           +0.000000000000000056*price[bar-787]
           -0.000000000000000056*price[bar-788]
           +0.000000000000000056*price[bar-789]
           -0.000000000000000056*price[bar-790]
           +0.000000000000000056*price[bar-791]
           -0.000000000000000057*price[bar-792]
           +0.000000000000000056*price[bar-793]
           -0.000000000000000057*price[bar-794]
           +0.000000000000000056*price[bar-795]
           -0.000000000000000056*price[bar-796]
           +0.000000000000000055*price[bar-797]
           -0.000000000000000057*price[bar-798]
           +0.000000000000000057*price[bar-799]
           -0.000000000000000057*price[bar-800]
           +0.000000000000000057*price[bar-801]
           -0.000000000000000057*price[bar-802]
           +0.000000000000000057*price[bar-803]
           -0.000000000000000059*price[bar-804]
           +0.000000000000000058*price[bar-805]
           -0.000000000000000057*price[bar-806]
           +0.000000000000000062*price[bar-807]
           -0.000000000000000056*price[bar-808]
           +0.000000000000000058*price[bar-809]
           -0.000000000000000058*price[bar-810]
           +0.000000000000000058*price[bar-811]
           -0.000000000000000058*price[bar-812]
           +0.000000000000000057*price[bar-813]
           -0.000000000000000057*price[bar-814]
           +0.000000000000000058*price[bar-815]
           -0.000000000000000058*price[bar-816]
           +0.000000000000000058*price[bar-817]
           -0.000000000000000058*price[bar-818]
           +0.000000000000000059*price[bar-819]
           -0.000000000000000058*price[bar-820]
           +0.000000000000000058*price[bar-821]
           -0.000000000000000058*price[bar-822]
           +0.000000000000000058*price[bar-823]
           -0.000000000000000058*price[bar-824]
           +0.000000000000000059*price[bar-825]
           -0.000000000000000058*price[bar-826]
           +0.000000000000000058*price[bar-827]
           -0.000000000000000059*price[bar-828]
           +0.000000000000000059*price[bar-829]
           -0.000000000000000059*price[bar-830]
           +0.000000000000000059*price[bar-831]
           -0.000000000000000059*price[bar-832]
           +0.000000000000000059*price[bar-833]
           -0.000000000000000059*price[bar-834]
           +0.000000000000000059*price[bar-835]
           -0.000000000000000059*price[bar-836]
           +0.000000000000000060*price[bar-837]
           -0.000000000000000058*price[bar-838]
           +0.000000000000000060*price[bar-839]
           -0.000000000000000059*price[bar-840]
           +0.000000000000000062*price[bar-841]
           -0.000000000000000060*price[bar-842]
           +0.000000000000000060*price[bar-843]
           -0.000000000000000059*price[bar-844]
           +0.000000000000000062*price[bar-845]
           -0.000000000000000060*price[bar-846]
           +0.000000000000000060*price[bar-847]
           -0.000000000000000060*price[bar-848]
           +0.000000000000000060*price[bar-849]
           -0.000000000000000060*price[bar-850]
           +0.000000000000000061*price[bar-851]
           -0.000000000000000061*price[bar-852]
           +0.000000000000000060*price[bar-853]
           -0.000000000000000061*price[bar-854]
           +0.000000000000000060*price[bar-855]
           -0.000000000000000061*price[bar-856]
           +0.000000000000000061*price[bar-857];

      //---- Initialization of a cell of the indicator buffer with the received value of KGHP
      ExtLineBuffer[bar]=KGHP;
     }
//---    
   return(rates_total);
  }
//+------------------------------------------------------------------+
